using System;
using de.ITVisions.DemoViewer;

namespace N2C
{
	/// <summary>
	/// Zusammenfassung fr boxing.
	/// </summary>
	/// 
  struct Dimension
  {
    public double Length;
    public double Width;
    public Dimension(double Length, double Width)
    {
      this.Length = Length;
      this.Width = Width;
    }
  }

[Demo]
 public class Datentypen
 {

  static public void run()
  {
		//int a, b, c;
		//string x, y, z;
		//System.Guid g1, g2, g3;

  int zahl = 1;
 // falsch:   string text = zahl;
 // falsch: string text = ((string) zahl);
// falsch:  string text = zahl as string;
  string text1 = zahl.ToString();
  string text2 = Convert.ToString(zahl);

  byte[] lottozahlen1 = new byte[7] { 23, 48, 3, 19, 20, 6, 9 };
  byte[] lottozahlen2 = new byte[] { 23, 48, 3, 19, 20, 6, 9 };
   byte[] lottozahlen3 = { 23, 48, 3, 19, 20, 6, 9 };
  
  }

  public void NullableTypes()
  {
   int a = 1;
   // Elegante Deklaration in C#
   int? b = 2;

   // a = null; // verboten!
   b = null; // Erlaubt


   System.Console.WriteLine(a);
   System.Console.WriteLine(b);

   int f = 0;

   f = a;
   if (b.HasValue) f = b.Value;

   f = b ?? -1;


   string z = "";

   Console.WriteLine(z);

   // Explizite Deklaration
   System.Nullable<Int32> c = null;
   c = 100;

   Demo.Print(c.HasValue.ToString());
   Demo.Print(c.Value.ToString()); // Achtung: Geht nur, wenn c tatschlich einen Wert hat!

   // Besser: "Null" abfangen
   Demo.Print ("b = " + ( b.HasValue ? b.Value.ToString() : "null"));



   // Neuer ?? Operator
   // --------------------------

   // Umwandlung eines Nullable Int in einen Int
   int? d = null;
   int e = d ?? -1;

   // Behandlung eines Strings
   string s = null;
   Demo.Print ("s = " + (s ?? "(kein Inhalt)"));

   // geht nicht Demo.Print("d = " + (d ?? "null"));
  }

  [System.CLSCompliant(false)]
 public void CLSKonformitaet()
  {
  UInt16 i = 16;
  }

 }

 public class boxing
	{
		public boxing()
		{

      // Beispiel: Werttyp ohne Member
			int i = 1234, i2;
      object oi, oi2;
           
      // Boxing
      oi = i;

      // Unboxing
      i2 = (int) oi;
      // or:
      i2 = Convert.ToInt32(oi);

      Console.WriteLine(i);
      Console.WriteLine(oi);
    
      i = 4567;
      
      Console.WriteLine(i);
      Console.WriteLine(oi);

      // Kopieroperationen fr int
      i2 = i;
      oi2 = oi;
      i2 = 8888;
      oi2 = 9999; 
      Console.WriteLine(i);
      Console.WriteLine(i2);
      Console.WriteLine(oi);
      Console.WriteLine(oi2);

      oi = "test";
      oi2 = oi;
      oi = "6666";

      Console.WriteLine(oi);
      Console.WriteLine(oi2);

//      oi = new Vater("1");
//      oi2 = oi;
//      ((Vater) oi).Name = "2";
//      Console.WriteLine(((Vater) oi).Name);
//      Console.WriteLine(((Vater) oi2).Name);

      // Beispiel: Wertetyp mit Membern
      Dimension d1,d2;

      d1.Length = 100;
      d1.Width = 100;

      d2 = d1;
      Console.WriteLine("d1.Length=" + d1.Length);
      Console.WriteLine("d2.Length=" + d2.Length);
     
      // Kopieroperationen fr Dimension: Referenzkopie!
      oi = d1;
      oi2 = oi;
        
    

      Console.WriteLine("oi.Length=" + ((Dimension) oi).Length);
      Console.WriteLine("oi2.Length=" + ((Dimension) oi2).Length);
		}
	}
}
