﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using de.WWWings;
using de.ITVisions.DALUtil;
using System.EnterpriseServices;
using System.Runtime.CompilerServices;
using System.Reflection;

namespace de.WWWings.DAL
{
 [Description("Flugmanager für WorldWideWings")]
 [System.EnterpriseServices.Synchronization(SynchronizationOption.Required)]
 [Transaction(TransactionOption.Required)]
 [ObjectPoolingAttribute(true, 10, 20)]
 [EventTrackingEnabled(true)]
 [System.Runtime.InteropServices.Guid("9C74BA6A-9D1C-4fe7-808E-04E6665D0251")]
 public class Flug_DataManager : ServicedComponent, DAL_CS.IFlug_DataManager
 {

public Flug_DataManager()
  {
	  DBUtil.SetDatabase(DBUtil.Providers.MSSQL, DBConfig.CONN_MSSQL);
   //DBUtil.SetDatabase(DBUtil.Providers.ACCESS, CONN_ACCESS);
  }

  // === Daten lesen mit einem DataReader
  public SqlDataReader AlleFluege_DR()
  {
   const string SQL = "Select * from FL_Fluege";
   return SQLUtil.GetReader(SQL);
  }

  // === Daten lesen mit einem DataReader
  public SqlDataReader AlleFluegeFuerAbflughafen_DR(string Abflughafen)
  {
   string SQL = "Select * from FL_Fluege where Fl_Abflughafen = '" + Abflughafen + "'";
   return SQLUtil.GetReader(SQL);
  }

  // === Daten lesen mit einem DataReader
  public SqlDataReader GetFlug_DR(long FlugNr)
  {
   string SQL = "Select * from FL_Fluege where fl_flugnr = " + FlugNr + "";
   SqlDataReader dr = SQLUtil.GetReader(SQL);
   dr.Read();
   return dr;
  }


  public static DataSet AlleFluege_DS()
  {
   const string SQL = "Select * from FL_Fluege";
   return SQLUtil.GetDataSet(SQL);
  }

  public static void Update(DataSet ds)
  {
   SQLUtil.UpdateDS(ds, "Select * from FL_fluege");
  }

  public static void Update(string FL_Abflugort, string FL_ZielOrt, long FL_Plaetze, bool FL_NichtRaucherFlug, DateTime FL_EingerichtetAm, int original_Fl_FlugNr)
  {
   SQLUtil.Execute("UPDATE Fl_Fluege SET FL_Abflugort = '" + FL_Abflugort + "', FL_ZielOrt = '" + FL_ZielOrt + "', FL_Plaetze = " + FL_Plaetze + " WHERE Fl_FlugNr = " + original_Fl_FlugNr);
   return;
  }

	   public static void Update(string FL_Abflugort, string FL_ZielOrt, DateTime FL_Datum, bool FL_NichtRaucherFlug, long FL_Plaetze, int FL_FreiePlaetze, long FL_PI_MI_MitarbeiterNr, long FL_AnzahlStarts, DateTime FL_EingerichtetAm, int original_Fl_FlugNr)
  {
   SQLUtil.Execute("UPDATE Fl_Fluege SET FL_Abflugort = '" + FL_Abflugort + "', FL_ZielOrt = '" + FL_ZielOrt + "', FL_Plaetze = " + FL_Plaetze + " WHERE Fl_FlugNr = " + original_Fl_FlugNr);
   return;
  }

  public static void Insert(string FL_Abflugort, string FL_ZielOrt, bool FL_NichtRaucherFlug, long FL_Plaetze, DateTime FL_EingerichtetAm, int FL_FlugNr)
  {
   SQLUtil.Execute("Insert into Fl_Fluege (Fl_Flugnr, FL_Abflugort, Fl_Zielort, Fl_Plaetze, Fl_NichtraucherFlug) Values (" + FL_FlugNr + ",'" + FL_Abflugort + "', '" + FL_ZielOrt + "', " + FL_Plaetze + ", '" + FL_NichtRaucherFlug + "')");
   return;
  }

  public static void Init()
  {
   string[] Flughaefen = { "Berlin", "Frankfurt", "München", "Hamburg", "Köln/Bonn", "Rom", "London", "Paris", "Mailand", "Prag", "Moskau", "New York", "Seattle" };

   int FlugNr = 500;
   foreach (string von in Flughaefen)
   {
    foreach (string nach in Flughaefen)
    {
     try
     {
      if (von != nach) Insert(von, nach, true, 0, DateTime.Now, FlugNr);
      System.Diagnostics.Trace.WriteLine(von + "->" + nach);
     }
     catch
     { }
     FlugNr++;
    }
   }
  }


  public static void LoescheFlug(int Original_Fl_FlugNr)
  {
   SQLUtil.Execute("Delete from Fl_Fluege where Fl_FlugNr = " + Original_Fl_FlugNr + "");
  }


 }
}
